#include "CRC8Generator.h"

uint8_t CRC8Generator::generateCRC(const uint8_t* data, size_t len) {
   if (data == NULL)
      return crcSeed;

   uint8_t c, bitMask8, TestBit8, tmp8, testBit;

   uint8_t crc = crcSeed;

   while (len--) {
      c = *data++;

      // Bits im Input umkehren
      tmp8 = 0;
      testBit = 1;
      for (bitMask8 = 1 << (8 - 1); bitMask8; bitMask8 >>= 1) {
         if (c & bitMask8) tmp8 |= testBit;
         testBit <<= 1;
      }
      c = tmp8;


      for (bitMask8 = 0x80; bitMask8; bitMask8 >>= 1) {
         TestBit8 = crc & 0x80;
         crc <<= 1;
         if (c & bitMask8)
            TestBit8 ^= 0x80;
         if (TestBit8)
            crc ^= 0x07;
      }
   }

   crc ^= 0xFF;

   return(crc);
}

void CRC8Generator::streamCRC(uint8_t b) {
   uint8_t bitMask8, TestBit8, tmp8, testBit;

   executor(b); // Byte weiter geben

   // Bits im Input umkehren
   tmp8 = 0;
   testBit = 1;
   for (bitMask8 = 1 << (8 - 1); bitMask8; bitMask8 >>= 1) {
      if (b & bitMask8) tmp8 |= testBit;
      testBit <<= 1;
   }
   b = tmp8;

   // CRC updaten
   for (bitMask8 = 0x80; bitMask8; bitMask8 >>= 1) {
      TestBit8 = crc & 0x80;
      crc <<= 1;
      if (b & bitMask8)
         TestBit8 ^= 0x80;
      if (TestBit8)
         crc ^= 0x07;
   }

}

uint8_t CRC8Generator::streamFin() {
   crc ^= 0xFF;

   executor(crc); // CRC weiter geben

   auto temp = crc;
   crc = crcSeed; // CRC zurck setzen
   return temp;
}
